package org.openxma.xmadsl.formatting;

import java.util.ArrayList;

import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.core.model.Import;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.core.model.ModelElement;

/**
 *
 */
public abstract class ModelFormatting {
	
    private final static String INDENT = "    ";
    private final static String INDENTx2= INDENT+INDENT;
    
    protected static String indent(int count) {
    	if (count < 0 ) {
    		throw new IllegalArgumentException("Count of indent must be greator or equal zero.");
    	}
    	if (count == 0) return "";
    	if (count == 1) return INDENT;
    	if (count == 2) return INDENTx2;    	
    	StringBuffer buf = new StringBuffer(INDENT.length()*3);
    	for (int i=0;i<count;i++) {
    		buf.append(INDENT);
    	}
    	return buf.toString();
    }

    /**
     * Formates the model.
     * @param obj
     * @return
     */
	public abstract ArrayList<String> formatModel(EObject obj);    

	protected void formatImports(Model model, ArrayList<String> data) {
		for (ModelElement modelElement: model.getElements()) {
			if (modelElement instanceof Import) {
				formatImport((Import) modelElement,data);
			}
		}
	}
 
    private void formatImport(Import imp, ArrayList<String> data ) {
        String s = "Import \""+ imp.getImportURI() + "\"";
        data.add(s);
    }	
}
